using System;

namespace ConsoleApp10
{
    class Program
    {
        static long navijaci = long.MaxValue;
        static void racun(long[,] matrica, int i, int j, long broj)
        {
            broj += matrica[i, j];
            if (broj >= navijaci) return;
            if (i == matrica.GetLength(0) - 1 && j == matrica.GetLength(1) - 1)
            {
                navijaci = broj;
                return;
            }
            if (i < matrica.GetLength(0) - 1) { if (matrica[i + 1, j] != -1) racun(matrica, i + 1, j, broj); }
            if (j < matrica.GetLength(1) - 1) { if (matrica[i, j + 1] != -1) racun(matrica, i, j + 1, broj); }
        }
        static void Main(string[] args)
        {
            string[] unos1 = Console.ReadLine().Split();
            int n = Convert.ToInt32(unos1[0]);
            int m = Convert.ToInt32(unos1[1]);

            long[,] matrica = new long[n, m];
            for (int i = 0; i < n; i++)
            {
                string[] unos2 = Console.ReadLine().Split();
                for (int j = 0; j < m; j++)
                {
                    matrica[i, j] = Convert.ToInt32(unos2[j]);
                }
            }
            int q = Convert.ToInt32(Console.ReadLine());
            int prosliA = -1;
            int prosliB = -1;
            long proslaVrednost = -1;
            long[] resenja = new long[q];
            for (int i = 0; i < q; i++)
            {
                string[] unos3 = Console.ReadLine().Split();
                int a = Convert.ToInt32(unos3[0]);
                int b = Convert.ToInt32(unos3[1]);
                if (proslaVrednost != -1)
                {
                    matrica[prosliA, prosliB] = proslaVrednost;
                }
                prosliA = a - 1;
                prosliB = b - 1;
                proslaVrednost = matrica[prosliA, prosliB];
                matrica[prosliA, prosliB] = -1;
                navijaci = long.MaxValue;
                racun(matrica, 0, 0, 0);
                resenja[i] = navijaci;
            }
            for (int i = 0; i < q; i++) Console.WriteLine(resenja[i]);
        }
    }
}